疯狂java


您现在的位置: 疯狂软件 >> 新闻资讯 >> 正文

java异常处理有哪些坏习惯


 

  你是否觉得已经的java水平很高呢?是不是觉得自己已经学会了java的异常处理机制呢?以下我们java培训机构准备了一段代码,看看你能否很快找出异常处理的几个问题。

 

 1. OutputStreamWriter out = ...

 

  2. java.sql.Connection conn = ...

  3. try { // ⑸

  4.  Statement stat = conn.createStatement();

  5.  ResultSet rs = stat.executeQuery(

  6. "select uid, name from user");

  7.  while (rs.next())

  8.  {

  9. out.println("ID:" + rs.getString("uid") // ⑹

  10.  ",姓名:" + rs.getString("name"));

  11.  }

  12.  conn.close(); // ⑶

  13.  out.close();

  14. }

  15. catch(Exception ex) // ⑵

  16. {

  17.  ex.printStackTrace(); //⑴,⑷

  18. }

  本文要做的是分析各种被称为反例的违背代码规范的坏习惯,帮助读者可以熟悉这些典型的例子,从而使开发者在实际工作中可以敏锐的避免这些问题。

  反例之一:丢弃异常

  代码:15行-18行。

  这段代码捕获异常未经任何治疗,可以被看作是Java编程的杀手。从问题的频率和邪恶的方面,它可能是和C / c++程序的一个臭名昭著的问题? ?不检查缓冲是不完整的。如果你看到废弃的(而不是抛出异常),可以百分之九十九确定这段代码有问题。

  这段代码是错误的,异常(几乎)总是意味着什么是错误的,或者至少是一些不同寻常的事情,我们不应该在程序发送求救信号保持沉默和完全不感兴趣。调用printStackTrace虽然不是“异常处理”。调用printStackTrace调试程序是有很好的帮助,但是程序调试阶段结束后,printStackTrace不应该异常处理模块承担主要责任。

  丢弃异常的情况非常普遍。当你看到threadDeath类的文档时候,您可以看到以下内容: “特别地,虽然出现ThreadDeath是一种 ‘正常的情形’,但ThreadDeath类是Error而不是Exception的子类,因为许多应用会捕获所有的Exception然后丢弃它不再理睬。”这意思是,虽然ThreadDeath代表一个常见的问题,但鉴于许多应用程序将试图捕获所有的异常和处理不当,那么JDK定义ThreadDeath到子类的错误,因为Error是代表普遍的应用程序不应该去捕捉严重的问题。因此,丢弃异常这一坏习惯会影响java本身的设计。

  那么,开发者该如何解决这样的问题呢?主要有四种选择:

  1,异常处理。针对异常采取一些行动,例如校正问题,提醒某人或某些处理程序,根据具体情况确定应该采取行动。

  2,抛出一个异常。异常处理代码在分析异常后,他们不能处理它,抛出一个异常也是一个选择。

  3,异常转换成另一个异常。在大多数情况下,这指的是一个低级异常转换应用级异常(它的意义更容易为用户理解异常)。

  4,不捕获异常。

  结论:自捕获异常,重要的是适当地处理。不要捕捉异常,然后把它扔掉,忽略了。

  反例之二:不指定具体的异常

  代码:15行。

  许多时候人们会被这样一种“美妙的”想法吸引:用一个catch语句捕获所有的异常。最常见的情形就是使用catch(Exception ex)语句。但实际上,在绝大多数情况下,这种做法不值得提倡。为什么呢?

  要理解其原因,我们必须回顾一下catch语句的用途。catch语句表示我们预期会出现某种异常,而且希望能够处理该异常。异常类的作用就是告诉 Java编译器我们想要处理的是哪一种异常。由于绝大多数异常都直接或间接从java.lang.Exception派生,catch(Exception ex)就相当于说我们想要处理几乎所有的异常。

  再来看看前面的代码例子。我们真正想要捕获的异常是什么呢?最明显的一个是SQLException,这是JDBC操作中常见的异常。另一个可能的异常是IOException,因为它要操作OutputStreamWriter。显然,在同一个catch块中处理这两种截然不同的异常是不合适的。如果用两个catch块分别捕获SQLException和IOException就要好多了。这就是说,catch语句应当尽量指定具体的异常类型,而不应该指定涵盖范围太广的Exception类。

  另一方面,除了这两个特定的异常,还有其他许多异常也可能出现。例如,如果由于某种原因,executeQuery返回了null,该怎么办?答案是让它们继续抛出,即不必捕获也不必处理。实际上,我们不能也不应该去捕获可能出现的所有异常,程序的其他地方还有捕获异常的机会??直至最后由JVM处理。

  结论二:在catch语句中尽可能指定具体的异常类型,必要时使用多个catch。不要试图处理所有可能出现的异常。

  反例之三:占用资源不释放

  代码:3行-14行。

  异常改变了程序正常的执行流程。这个道理虽然简单,却常常被人们忽视。如果程序用到了文件、Socket、JDBC连接之类的资源,即使遇到了异常,也要正确释放占用的资源。为此,Java提供了一个简化这类操作的关键词finally。

  finally是样好东西:不管是否出现了异常,Finally保证在try/catch/finally块结束之前,执行清理任务的代码总是有机会执行。遗憾的是有些人却不习惯使用finally。

  当然,编写finally块应当多加小心,特别是要注意在finally块之内抛出的异常??这是执行清理任务的最后机会,尽量不要再有难以处理的错误。

  结论三:保证所有资源都被正确释放。充分运用finally关键词。

  反例之四:不说明异常的详细信息

  代码:3行-18行。

  仔细观察这段代码:如果循环内部出现了异常,会发生什么事情?我们可以得到足够的信息判断循环内部出错的原因吗?不能。我们只能知道当前正在处理的类发生了某种错误,但却不能获得任何信息判断导致当前错误的原因。

  printStackTrace的堆栈跟踪功能显示出程序运行到当前类的执行流程,但只提供了一些最基本的信息,未能说明实际导致错误的原因,同时也不易解读。

  因此,在出现异常时,最好能够提供一些文字信息,例如当前正在执行的类、方法和其他状态信息,包括以一种更适合阅读的方式整理和组织printStackTrace提供的信息。

  结论四:在异常处理模块中提供适量的错误原因信息,组织错误信息使其易于理解和阅读。

  反例之五:过于庞大的try块

  代码:3行-14行。

  经常可以看到有人把大量的代码放入单个try块,实际上这不是好习惯。这种现象之所以常见,原因就在于有些人图省事,不愿花时间分析一大块代码中哪几行代码会抛出异常、异常的具体类型是什么。把大量的语句装入单个巨大的try块就象是出门旅游时把所有日常用品塞入一个大箱子,虽然东西是带上了,但要找出来可不容易。

  一些新手常常把大量的代码放入单个try块,然后再在catch语句中声明Exception,而不是分离各个可能出现异常的段落并分别捕获其异常。这种做法为分析程序抛出异常的原因带来了困难,因为一大段代码中有太多的地方可能抛出Exception。

  结论五:尽量减小try块的体积。

  反例之六:输出数据不完整

  代码:7行-11行。

  不完整的数据是Java程序的隐形杀手。仔细观察这段代码,考虑一下如果循环的中间抛出了异常,会发生什么事情。循环的执行当然是要被打断的,其次,catch块会执行??就这些,再也没有其他动作了。已经输出的数据怎么办?使用这些数据的人或设备将收到一份不完整的(因而也是错误的)数据,却得不到任何有关这份数据是否完整的提示。对于有些系统来说,数据不完整可能比系统停止运行带来更大的损失。

  较为理想的处置办法是向输出设备写一些信息,声明数据的不完整性;另一种可能有效的办法是,先缓冲要输出的数据,准备好全部数据之后再一次性输出。

  结论六:全面考虑可能出现的异常以及这些异常对执行流程的影响。

  改写后的代码

  根据上面的讨论,下面给出改写后的代码。也许有人会说它稍微有点啰嗦,但是它有了比较完备的异常处理机制。

  1. OutputStreamWriter out = ...

  2. java.sql.Connection conn = ...

  3. try {

  4.  Statement stat = conn.createStatement();

  5.  ResultSet rs = stat.executeQuery(

  6. "select uid, name from user");

  7.  while (rs.next())

  8.  {

  9. out.println("ID:" + rs.getString("uid") + ",姓名: " + rs.getString("name"));

  10.  }

  11. }

  12. catch(SQLException sqlex)

  13. {

  14.  out.println("警告:数据不完整");

  15.  throw new ApplicationException("读取数据时出现SQL错误", sqlex);

  16. }

  17. catch(IOException ioex)

  18. {

  19.  throw new ApplicationException("写入数据时出现IO错误", ioex);

  20. }

  21. finally

  22. {

  23.  if (conn != null) {

  24. try {

  25.  conn.close();

  26. }

  27. catch(SQLException sqlex2)

  28. {

  29.  System.err(this.getClass().getName() + ".mymethod - 不能关闭数据库连接: " + sqlex2.toString());

  30. }

  31.  }

  32.

  33.  if (out != null) {

  34. try {

  35.  out.close();

  36. }

  37. catch(IOException ioex2)

  38. {

  39.  System.err(this.getClass().getName() + ".mymethod - 不能关闭输出文件" + ioex2.toString());

  40. }

  41.  }

  42. }

  以上介绍的就是关于异常处理中会遇到的一些问题,也是很多人都没注意的一些问题。有时候,这些常识和经验才是我们最好的老师。经验来自实践,相信以上所说的能对大家有帮助!本文来自疯狂软件,转载请注明。